%% Copyright Pieter Abbeel
%%

%% 

clear; clc; close all;
% delta_t = 0.1;
% 
% % let's generate a path:
% 
% 	
% u = [ones(1,200); ones(1,100) -ones(1,100)];
% 
% T = size(u,2);
% x0 = [0;0;0;0;0];
% 
% Sigma_w = diag([0.0001  0.0001  0.0001  0.04  0.04]);
% w = sqrtm(Sigma_w)*randn(length(x0), T);
% 
% x(:,1) = x0;
% 
% for t=2:T
% 	x(:,t) = f_car(x(:,t-1), u(:,t-1), w(:,t-1), delta_t);
% end
% 
% % let's plot the path we obtained:
% 
% figure; plot(x(1,:), x(2,:)); axis equal;
% figure; plot(x');
% 


% % let's generate some measurements along the path
% 
% % GPS measurements and heading measurements:
% 
% 
% Sigma_v_gc = diag([0.01  0.01   0.01]);
% v_gc = sqrtm(Sigma_v_gc)*randn(3, T);
% 
% Sigma_v_g = diag([0.01 0.01])*100;
% v_g = sqrtm(Sigma_v_g)*randn(2,T);
% 
% 
% for t=1:T
% 	z_gc(:,t) = gps_and_compass(x(:,t), v_gc(:,t));
% 	z_g(:,t) = gps(x(:,t), v_g(:,t));
% end
% 
% % let's pick some landmarks along the path:
% 
% L = 20; % #landmarks
% landmark_visibility_distance = 10; % if not this close, landmark will not be observed
% R_landmarks = eye(2);
% 
% % randomly pick some landmarks
% for l=1:L
% 	landmarks(:,l) = x(1:2, round(T*l/L)) + 2*randn(2,1);
% end
% 
% obs_count = zeros(L,1);
% for m=1:L
% 	obs_times{m} = [];
% end
% 
% for t=1:T
% 	for m=1:L
% 		% only perform a measurement for landmarks very 10 ticks and if landmark close enough:
% 		if( mod(t-1, 5)==0 & norm(landmarks(:,m)-x(1:2,t)) < landmark_visibility_distance )
% 			v_landmarks = sqrtm(R_landmarks)*randn(2,1);
% 			z_landmarks{t}{m}.meas = g_unlocalized_landmarks( [x(:,t); landmarks(:)], m, v_landmarks);%YOUR code
% 			z_landmarks{t}{m}.add_meas_info = m; %stored index of landmark that was measured
% 			obs_count(m) = obs_count(m)+1;
% 			obs_times{m} = [obs_times{m} t];
% 		else
% 			z_landmarks{t}{m} = []; % "help isempty" to find out how to check for this to be empty
% 		end
% 	end
% end
% 
% z_landmarks = z_unlocalized_landmarks;
% % 
% save p6_data.mat x u Sigma_w T x0 delta_t Sigma_v_gc Sigma_v_g z_gc z_g L landmark_visibility_distance R_landmarks landmarks z_landmarks 

load p6_data.mat


% take a look at data:
figure; hold on; plot(x(1,:), x(2,:)); plot(landmarks(1,:), landmarks(2,:), 'rx'); axis equal;


% all right, let's run the Kalman filters

init_x = x0;
init_V = eye(5)*0.01;


%% 1: run E/UKF for when GPS and compass measurements are both available; 
%% 1a plot found position trajectory (y vs. x coordinate) and make sure to call
%% "axis equal" both for filtering and smoothing
%% 1b plot found state estimates as a function of time, both for filtering
%% and smoothing

% to use:
% z_gc: gps+compass measurements
% @f_car: dynamics model for car
% @gps_and_compass: measurement model for gps and compass
% u: controls applied
% Sigma_w: process noise covariance
% Sigma_v_gc: measurement noise covariance
% init_x: initial state estimate mean
% init_V: initial state estimate covariance
% delta_t: time step used





%% 2: run E/UKF for when only GPS measurements are available; 
%% 2a plot found position trajectory (y vs. x coordinate) and make sure to call
%% "axis equal" both for filtering and smoothing
%% 2b plot found state estimates as a function of time, both for filtering
%% and smoothing


% to use:
% z_g: gps measurements
% @f_car: dynamics model for car
% @gps: measurement model for gps
% u: controls applied
% Sigma_w: process noise covariance
% Sigma_v_g: measurement noise covariance
% init_x: initial state estimate mean
% init_V: initial state estimate covariance
% delta_t: time step used





%% 3: run E/UKF for when landmarks with known global coordinates are observed; 
%% 3a plot found position trajectory (y vs. x coordinate) and make sure to call
%% "axis equal" both for filtering and smoothing; also plot the landmarks
%%  on this figure
%% 3b plot found state estimates as a function of time, both for filtering
%% and smoothing


% to use:
% z_landmarks: landmark measurements in car frame
% @f_car: dynamics model for car
% @g_known_landmarks: measurement model for landmarks for when landmark
% location and ID are known
% u: controls applied
% Sigma_w: process noise covariance
% R_landmarks: measurement noise covariance
% init_x: initial state estimate mean
% init_V: initial state estimate covariance
% delta_t: time step used

%NOTE: landmarks are always measured in a coordinate frame attached to the car, 
% that has the x-axis correspond to the forward direction for the car, and 
% the y-axis correspond to the sideways-to-the-left direction.
% For example, if the car's (x,y,theta) = (0, 0, pi/2) and the landmark is at (1,0), then the
%landmark measurement would be (0, -1).


%% 4: e/ukf-slam with known data association: run E/UKF for when landmark
%% IDs are known, but global coordinates of landmarks are unknown and
%% inferred by the E/UKF
%% 4a plot found position trajectory (y vs. x coordinate) and make sure to call
%% "axis equal" both for filtering and smoothing; include pose estimates of
%% landmarks from first time they are observed until time T
%% 4b plot found state estimates as a function of time, both for filtering
%% and smoothing


% to use:
% z_landmarks: landmark measurements in car frame
% @f_car: dynamics model for car
% @g_unknown_landmarks: measurement model for landmarks for when landmark
% ID is known, but their location is not known, and hence their location is
% part of the state
% u: controls applied
% Sigma_w: process noise covariance
% R_landmarks: measurement noise covariance
% init_x: initial state estimate mean
% init_V: initial state estimate covariance
% delta_t: time step used

% now the state is augmented with landmark locations, the following
% initialization worked well for me:

init_x0 = zeros(5+2*L,1);
init_V0 = diag([diag(init_V); ones(2*L,1)*1e4]);
Q = diag([diag(Sigma_w) ; zeros(2*L,1)]);





%% 5: ekf-slam with unknown data association: run E/UKF for when landmark
%% IDs are not known when a landmark is observed; this means your E/UKF
%% will spawn into multiple E/UKF whenever there is ambiguity about which
%% landmark was observed;  [note there is no way to recover the
%% groundtruth ID's; for convenience of coding feel free to use the
%% knowledge of the total number of landmarks that will be
%% encountered (so you can keep the state size constant, as done in
%% initialization above)]
%% 5a plot found position trajectory (y vs. x coordinate) and make sure to call
%% "axis equal" both for filtering and smoothing; include pose estimates of
%% landmarks from first time they are observed until time T
%% 5b plot found state estimates as a function of time, both for filtering
%% and smoothing

% to use:
% same as previous, EXCEPT that now you can NOT use the ID's of the
% landmarks associated with each measurement; association of
% measurements with particular landmarks can be done based on
% distance between measurement and where landmarks have been
% estimated to be.  When your E/UKF spawns into multiple E/UKFs,
% you want to keep track of the likelihood of the measurements in
% each one of them to prune out some if/when you start having too many
% to be practical




